am 3efb17f6: (-s ours) DO NOT MERGE: Drop SDK@870732 from klp-dev.

* commit '3efb17f6b41a81910ffa7fa5ea7c11b9454f7dad':
  DO NOT MERGE: Drop SDK@870732 from klp-dev.
diff --git a/19/android.jar b/19/android.jar
index afdb007..77aabd3 100644
--- a/19/android.jar
+++ b/19/android.jar
Binary files differ
diff --git a/19/uiautomator.jar b/19/uiautomator.jar
index 844ce29..f7a644f 100644
--- a/19/uiautomator.jar
+++ b/19/uiautomator.jar
Binary files differ
diff --git a/current/android.jar b/current/android.jar
index ca00117..332749e 100644
--- a/current/android.jar
+++ b/current/android.jar
Binary files differ
diff --git a/current/uiautomator.jar b/current/uiautomator.jar
index ac00aaf..9435418 100644
--- a/current/uiautomator.jar
+++ b/current/uiautomator.jar
Binary files differ
diff --git a/tools/Android.mk b/tools/Android.mk
index d3cef0c..51e9942 100644
--- a/tools/Android.mk
+++ b/tools/Android.mk
@@ -120,6 +120,55 @@
 	$(hide) chmod 755 $@
 
 ##################################
+include $(CLEAR_VARS)
+
+# We have to call copy-file-to-new-target instead of simply including
+# $(BUILD_PREBUILT) here, because we must put dx.jar, shrinkedAndroid.jar and mainDexClasses.rules
+# as dependecy of mainDexClasses.
+
+LOCAL_MODULE := mainDexClasses
+LOCAL_IS_HOST_MODULE := true
+LOCAL_MODULE_CLASS := EXECUTABLES
+LOCAL_MODULE_TAGS := optional
+
+include $(BUILD_SYSTEM)/base_rules.mk
+
+$(LOCAL_BUILT_MODULE): $(HOST_OUT_JAVA_LIBRARIES)/dx$(COMMON_JAVA_PACKAGE_SUFFIX)
+$(LOCAL_BUILT_MODULE): $(HOST_OUT_JAVA_LIBRARIES)/shrinkedAndroid$(COMMON_JAVA_PACKAGE_SUFFIX)
+$(LOCAL_BUILT_MODULE): $(HOST_OUT_EXECUTABLES)/mainDexClasses.rules
+$(LOCAL_BUILT_MODULE): $(LOCAL_PATH)/mainDexClasses | $(ACP)
+	@echo "Copy: $(PRIVATE_MODULE) ($@)"
+	$(copy-file-to-new-target)
+	$(hide) chmod 755 $@
+
+##################################
+
+include $(CLEAR_VARS)
+
+LOCAL_MODULE := mainDexClasses.rules
+LOCAL_SRC_FILES := mainDexClasses.rules
+LOCAL_MODULE_CLASS := EXECUTABLES
+LOCAL_MODULE_TAGS := optional
+LOCAL_MODULE_SUFFIX :=
+LOCAL_BUILT_MODULE_STEM := mainDexClasses.rules
+LOCAL_IS_HOST_MODULE := true
+
+include $(BUILD_PREBUILT)
+
+##################################
+include $(CLEAR_VARS)
+
+LOCAL_MODULE := shrinkedAndroid
+LOCAL_SRC_FILES := lib/shrinkedAndroid.jar
+LOCAL_MODULE_CLASS := JAVA_LIBRARIES
+LOCAL_MODULE_TAGS := optional
+LOCAL_MODULE_SUFFIX := $(COMMON_JAVA_PACKAGE_SUFFIX)
+LOCAL_BUILT_MODULE_STEM := dx$(COMMON_JAVA_PACKAGE_SUFFIX)
+LOCAL_IS_HOST_MODULE := true
+
+include $(BUILD_PREBUILT)
+
+##################################
 
 endif # TARGET_BUILD_APPS or TARGET_BUILD_PDK
 
@@ -182,6 +231,12 @@
 
 ##################################
 
+endif # TARGET_BUILD_APPS only
+
+# Only build Clang/LLVM components when forced to.
+ifneq (true,$(FORCE_BUILD_LLVM_COMPONENTS))
+
+##################################
 include $(CLEAR_VARS)
 
 LOCAL_MODULE := libLLVM
@@ -205,6 +260,4 @@
 
 include $(BUILD_PREBUILT)
 
-##################################
-
-endif # TARGET_BUILD_APPS only
+endif #!FORCE_BUILD_LLVM_COMPONENTS
diff --git a/tools/lib/dx.jar b/tools/lib/dx.jar
index 746163b..1471c3b 100644
--- a/tools/lib/dx.jar
+++ b/tools/lib/dx.jar
Binary files differ
diff --git a/tools/lib/shrinkedAndroid.jar b/tools/lib/shrinkedAndroid.jar
new file mode 100644
index 0000000..68b53fc
--- /dev/null
+++ b/tools/lib/shrinkedAndroid.jar
Binary files differ
diff --git a/tools/mainDexClasses b/tools/mainDexClasses
new file mode 100755
index 0000000..034d47e
--- /dev/null
+++ b/tools/mainDexClasses
@@ -0,0 +1,158 @@
+#!/bin/bash
+#
+# Copyright (C) 2013 The Android Open Source Project
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+function makeTempJar ()
+{
+  local tempDir=/tmp
+  if [ ! -e "${tempDir}" ]; then
+    tempDir=.
+  fi
+  local tempfile="${tempDir}/mainDexClasses-$$.tmp.jar"
+  if [ -e "${tempfile}" ]; then
+    echo "Failed to create temporary file" >2
+    exit 6
+  fi
+  echo "${tempfile}"
+}
+
+function cleanTmp ()
+{
+  if [ -e "${tmpOut}" ] ; then
+    rm "${tmpOut}"
+  fi
+}
+
+
+# Set up prog to be the path of this script, including following symlinks,
+# and set up progdir to be the fully-qualified pathname of its directory.
+prog="$0"
+
+while [ -h "${prog}" ]; do
+    newProg=`/bin/ls -ld "${prog}"`
+    newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
+    if expr "x${newProg}" : 'x/' >/dev/null; then
+        prog="${newProg}"
+    else
+        progdir=`dirname "${prog}"`
+        prog="${progdir}/${newProg}"
+    fi
+done
+oldwd=`pwd`
+progdir=`dirname "${prog}"`
+cd "${progdir}"
+progdir=`pwd`
+prog="${progdir}"/`basename "${prog}"`
+cd "${oldwd}"
+
+baserules="${progdir}"/mainDexClasses.rules
+if [ ! -r ${baserules} ]; then
+    echo `basename "$prog"`": can't find mainDexClasses.rules" 1>&2
+    exit 1
+fi
+
+jarfile=dx.jar
+libdir="$progdir"
+
+if [ ! -r "$libdir/$jarfile" ]; then
+    # set dx.jar location for the SDK case
+    libdir="$libdir/lib"
+fi
+
+
+if [ ! -r "$libdir/$jarfile" ]; then
+    # set dx.jar location for the Android tree case
+    libdir=`dirname "$progdir"`/framework
+fi
+
+if [ ! -r "$libdir/$jarfile" ]; then
+    echo `basename "$prog"`": can't find $jarfile" 1>&2
+    exit 1
+fi
+
+proguardExec="proguard.sh"
+proguard=${PROGUARD_HOME}/bin/${proguardExec}
+
+if [ ! -r "${proguard}" ]; then
+  # set proguard location for the SDK case
+  proguardBaseDir=`dirname "$progdir"`
+  # "${progdir}"/../..
+  proguardBaseDir=`dirname "$proguardBaseDir"`
+  proguard="${proguardBaseDir}"/tools/proguard/bin/${proguardExec}
+fi
+
+if [ ! -r "${proguard}" ]; then
+  # set proguard location for the Android tree case
+  proguardBaseDir=`dirname "$proguardBaseDir"`
+  # "${progdir}"/../../../..
+  proguardBaseDir=`dirname "$proguardBaseDir"`
+  proguard="${proguardBaseDir}"/external/proguard/bin/${proguardExec}
+fi
+
+if [ ! -r "${proguard}" ]; then
+    proguard="`which proguard`"
+fi
+
+if [ -z "${proguard}" -o ! -r "${proguard}" ]; then
+    proguard="`which ${proguardExec}`"
+fi
+
+if [ -z "${proguard}" -o ! -r "${proguard}" ]; then
+    echo `basename "$prog"`": can't find ${proguardExec}" 1>&2
+    exit 1
+fi
+
+shrinkedAndroidJar="${SHRINKED_ANDROID_JAR}"
+if [ -z "${shrinkedAndroidJar}" ]; then
+  shrinkedAndroidJar=shrinkedAndroid.jar
+fi
+
+if [ ! -r "${shrinkedAndroidJar}" ]; then
+  shrinkedAndroidJar=${libdir}/${shrinkedAndroidJar}
+fi
+
+if [ ! -r "${shrinkedAndroidJar}" ]; then
+    echo `basename "$prog"`": can't find shrinkedAndroid.jar" 1>&2
+    exit 1
+fi
+
+if [ "$OSTYPE" = "cygwin" ]; then
+    # For Cygwin, convert the jarfile path into native Windows style.
+    jarpath=`cygpath -w "$libdir/$jarfile"`
+  proguard=`cygpath -w "${proguard}"`
+  shrinkedAndroidJar=`cygpath -w "${shrinkedAndroidJar}"`
+else
+    jarpath="$libdir/$jarfile"
+fi
+
+if expr "x$1" : 'x--output' >/dev/null; then
+    exec 1>$2
+    shift 2
+fi
+
+if [ $# -ne 1 ]; then
+  echo "Usage : $0 [--output <output file>] <application path>" 1>&2
+  exit 2
+fi
+
+tmpOut=`makeTempJar`
+
+trap cleanTmp 0
+
+${proguard} -injars ${@} -dontwarn -forceprocessing  -outjars ${tmpOut} \
+  -libraryjars "${shrinkedAndroidJar}" -dontoptimize -dontobfuscate -dontpreverify \
+  -include "${baserules}" 1>/dev/null || exit 10
+
+java -cp "$jarpath" com.android.multidex.ClassReferenceListBuilder "${tmpOut}" ${@} ||  exit 11
diff --git a/tools/mainDexClasses.rules b/tools/mainDexClasses.rules
new file mode 100644
index 0000000..4a3bb50
--- /dev/null
+++ b/tools/mainDexClasses.rules
@@ -0,0 +1,17 @@
+  -keep public class * extends android.app.Instrumentation {

+  }

+  -keep public class * extends android.app.Application {

+  }

+  -keep public class * extends android.app.Activity {

+  }

+  -keep public class * extends android.app.Service {

+  }

+  -keep public class * extends android.content.ContentProvider {

+  }

+  -keep public class * extends android.content.BroadcastReceiver {

+  }

+  -keep public class * extends android.app.backup.BackupAgent {

+  }

+  -keep class android.support.multidex.** {

+    *;

+  }
\ No newline at end of file
diff --git a/tools/windows/libLLVM.dll b/tools/windows/libLLVM.dll
new file mode 100755
index 0000000..bb6b90d
--- /dev/null
+++ b/tools/windows/libLLVM.dll
Binary files differ
diff --git a/tools/windows/libclang.dll b/tools/windows/libclang.dll
new file mode 100755
index 0000000..5ef3bc4
--- /dev/null
+++ b/tools/windows/libclang.dll
Binary files differ